package com.akjava.gwt.lib.hangoutsutils.client.widgets;

import java.util.ArrayList;
import java.util.List;

import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.RadioButton;

public class VolumeRadioboxes extends HorizontalPanel{
		private static int id=0;
		List<RadioButton> buttons=new ArrayList<RadioButton>();
		
		/**
		 * I'm so sorry,I dont know how to implement ChangeEvent
		 * so I use custom event
		 */
		List<VolumeRadioboxesListener> changeListeners=new ArrayList<VolumeRadioboxesListener>();	
		 public static interface VolumeRadioboxesListener {
			 public void changed(int newValue);
		 }
		 
		public synchronized void addListener(VolumeRadioboxesListener handler){
			changeListeners.add(handler);
		}
		public synchronized void removeChangeHandler(VolumeRadioboxesListener handler){
			changeListeners.remove(handler);
		}
		
		public  synchronized void fireEvents(){
			for(VolumeRadioboxesListener listener:changeListeners){	
				listener.changed(getValue());
			}
		}
		private int lastSelection;
		public VolumeRadioboxes(){
			id++;
			for(int i=0;i<=5;i++){
				addButton(i);
			}
			//setValue(1);
		}
		
		private void addButton(int value){
			RadioButton vol=new RadioButton("VolumeRadioBoxes"+id);
			vol.addClickHandler(new ClickHandler() {
				@Override
				public void onClick(ClickEvent event) {
					int selection=getValue();
					if(lastSelection!=selection){
						fireEvents();
					}
					lastSelection=selection;
				}
			});
			vol.setText(""+value);
			add(vol);
			buttons.add(vol);
		}
		public int getValue(){
			
			for(int i=0;i<buttons.size();i++){
				if(buttons.get(i).getValue()){
					return i;
				}
			}
			return 5;
		}
		
		public double getVolume(){
			return 0.2*getValue();
		}
		public void setVolume(double value){
			int index=(int) (value/0.2);
			
			setValue(index);
		}
		public void setValue(int value){
			value=Math.max(0, value);
			value=Math.min(5,value);
			buttons.get(value).setValue(true);
			lastSelection=value;
			
		}
		
	}